(*
Copyright 2009-2013 Christian Sternagel, René Thiemann

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
*)
theory Orthogonality_Impl
imports 
  Orthogonality 
  Critical_Pairs_Impl
  "../Framework/QDP_Framework_Impl"
begin


subsection \<open>Proving confluence of TRSs\<close>

definition check_weakly_orthogonal where 
  "check_weakly_orthogonal R = do {
           check_left_linear_trs R;
           check_allm (\<lambda> (l,r). check (is_Fun l) (shows ''the TRS has variables as left-hand sides'')) R;
           check_allm (\<lambda> (b,s,t). do {
              check (s = t) (shows ''there is a non-trivial critical pair: '' +@+ shows_term s +@+ shows '' <- . -> ''
                +@+ shows_term t)
            }) (critical_pairs_impl R R) 
         }  <+? (\<lambda>s. s +@+ shows_nl +@+ shows ''hence, the following TRS is not weakly orthogonal '' +@+ shows_nl +@+ shows_trs R
             +@+ indent s)"

lemma check_weakly_orthogonal: assumes "isOK(check_weakly_orthogonal R)"
  shows "CR (rstep (set R))"
  by (rule weakly_orthogonal_rstep_CR, insert assms[unfolded check_weakly_orthogonal_def], auto)

end
