(*
Copyright 2009-2013 Christian Sternagel, René Thiemann

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
*)
theory Sum
imports "../TermFun"
begin

fun hd :: "nat list \<Rightarrow> nat" where
  "hd [] = 0" (* underspecification not supported *)
| "hd (x#xs) = x"

fun null :: "'a list \<Rightarrow> bool" where
  "null [] = True"
| "null _  = False"

function sum :: "nat list \<Rightarrow> nat" where
  "sum xs = (if null xs then 0
                        else hd xs + sum (tl xs))"
  by pat_completeness auto

lemmas tl_simps = list.sel(2-3)

define_trs null.simps
define_trs tl_simps
define_trs hd.simps
define_trs (no_sim) sum.psimps

termination sum
  apply (trs_reduce sum)
  apply expand_trs_problem
  export_termination_problem "sum.xml"
  apply (ceta_import_proof "proofs/sum.proof.xml")
  apply eval
done

end
